/** @file
 * fobOp}NWB
 *
 * Ɏ}ŃAThemis::stringň͂Ă̂ŁAThemis::stringnĂvB
 *
 * Themis_DebugAlways`()  NDEBUG Ȏ삷邯ǁA
 * Themis_Debug`()  NDEBUG Ȏ͉sȂ̂ƂB
 * NDEBUG ȎɈꎞIɃO肽ꍇȂǂɗpB
 * 胊[XƂɏYȂ悤ɒӂ邱ƁB
 *
 * @author aki.
 */
#pragma once
#include <boost/current_function.hpp>
namespace Themis {

inline Themis::string DebugString(const Themis::string& str) { return str; }
Themis::string DebugString(const char* psz);
Themis::string DebugItoA(int n);
void DebugOutput(const Themis::string& msg);
void DebugLog(const Themis::string& msg);
bool DebugMsgBox(const Themis::string& msg);
LPVOID DebugGetLastError();

#define Themis__T(x) L##x
#define Themis_T(x) Themis__T(x)

/// t@CƂȕԂ
#define Themis_DebugAlwaysWhereIsHere() \
    (Themis_T(BOOST_CURRENT_FUNCTION) L"\r\n in " \
     Themis_T(__FILE__) L" (" + Themis::DebugItoA(__LINE__) + L")")

/// bZ[W{bNX̕\
#define Themis_DebugAlwaysWarning(___0) do { \
        if (Themis::DebugMsgBox(Themis::DebugString(___0) + L"\r\n\r\n" + Themis_DebugAlwaysWhereIsHere())) { \
            __asm int 3 \
        } \
    } while (false)
/// ApibZ[W{bNX̕\
#define Themis_DebugAlwaysApiError() do { \
        LPVOID pMsgBuf = Themis::DebugGetLastError(); \
        Themis_DebugAlwaysWarning(L"Debug ApiError : " +  Themis::DebugString(reinterpret_cast<LPTSTR>(pMsgBuf))); \
        ::LocalFree(pMsgBuf); \
    } while (false)
/// falseȂ烁bZ[W\
#define Themis_DebugAlwaysAssert(___0) \
    if (___0) {} else Themis_DebugAlwaysWarning(Themis::DebugString(L"Assert Error : ") + L ## #___0)
/// ApiAssert
#define Themis_DebugAlwaysAssertApi(___0) \
    if (___0) {} else Themis_DebugAlwaysApiError()

/// Assert + if
#define Themis_DebugAlwaysAssertIf(___0) \
    if (!(___0)) { Themis_DebugAlwaysWarning(Themis::DebugString(L"Assert Error : ") + L ## #___0); } else if (true)
/// ApiAssert + if
#define Themis_DebugAlwaysAssertApiIf(___0) \
    if (!(___0)) { Themis_DebugAlwaysApiError(); } else if (true)

/// fobKփbZ[Wo
#define Themis_DebugAlwaysOutput(___0) \
    Themis::DebugOutput(Themis::DebugString(___0))
    // Themis::DebugOutput(Themis::DebugString(___0) + L" {" + Themis_DebugAlwaysWhereIsHere() + L"}")
/// OEBhEփbZ[Wo
#define Themis_DebugAlwaysLog(___0) \
    Themis::DebugLog(Themis::DebugString(___0))
    // (Themis::DebugString(___0) + L" {" + Themis_DebugAlwaysWhereIsHere() + L"}")
/// ApibZ[W{bNX̕\
#define Themis_DebugAlwaysApiLog() do { \
        LPVOID pMsgBuf = Themis::DebugGetLastError(); \
        Themis_DebugAlwaysLog(L"ApiError : " +  Themis::DebugString(reinterpret_cast<LPTSTR>(pMsgBuf))); \
        ::LocalFree(pMsgBuf); \
    } while (false)
/// falseȂ烁bZ[W\
#define Themis_DebugAlwaysAssertLog(___0) \
    if (___0) {} else Themis_DebugAlwaysLog(Themis::string(L"Assert Error : ") + L ## #___0)
/// ApiAssert
#define Themis_DebugAlwaysAssertApiLog(___0) \
    if (___0) {} else Themis_DebugAlwaysApiLog()

#ifdef NDEBUG

/// bZ[W{bNX̕\
# define Themis_DebugWarning(___0)      ((void)0)
/// ApiG[ɃbZ[W{bNX̕\
# define Themis_DebugApiError()         ((void)0)
/// falseȂ烁bZ[W\
# define Themis_DebugAssert(___0)       ((void)0)
/// ApiAssert
# define Themis_DebugAssertApi(___0)    ((void)0)
/// Assert + if
# define Themis_DebugAssertIf(___0)     if (___0)
/// ApiAssert + if
# define Themis_DebugAssertIfApi(___0)  if (___0)

/// fobKփbZ[Wo
# define Themis_DebugOutput(___0)          ((void)0)
/// OEBhEփbZ[Wo
# define Themis_DebugLog(___0)          ((void)0)
/// ApiG[ɃOEBhE֏o
# define Themis_DebugApiLog()           ((void)0)
/// Assert̏o͐悪Logȃo[W
# define Themis_DebugAssertLog(___0)    ((void)0)
/// AssertApȉo͐悪Logȃo[W
# define Themis_DebugAssertApiLog(___0) ((void)0)

/// BȂƂ\
# define Themis_DebugTrespass()         __assume(0)

/// fobKN
# define Themis_DebugBreak()            ((void)0)


#else

# define Themis_DebugWarning(___0)      Themis_DebugAlwaysWarning(___0)
# define Themis_DebugApiError()         Themis_DebugAlwaysApiError()
# define Themis_DebugAssert(___0)       Themis_DebugAlwaysAssert(___0)
# define Themis_DebugAssertApi(___0)    Themis_DebugAlwaysAssertApi(___0)
# define Themis_DebugAssertIf(___0)     Themis_DebugAlwaysAssertIf(___0)
# define Themis_DebugAssertApiIf(___0)  Themis_DebugAlwaysAssertApiIf(___0)

# define Themis_DebugOutput(___0)       Themis_DebugAlwaysOutput(___0)
# define Themis_DebugLog(___0)          Themis_DebugAlwaysLog(___0)
# define Themis_DebugApiLog()           Themis_DebugAlwaysApiLog()
# define Themis_DebugAssertLog(___0)    Themis_DebugAlwaysAssertLog(___0)
# define Themis_DebugAssertApiLog(___0) Themis_DebugAlwaysAssertApiLog(___0)

# define Themis_DebugTrespass()         Themis_DebugWarning(L"TrespassȃR[hs܂");

# define Themis_DebugBreak()            _asm { int 3 }

#endif

}
