#pragma once
namespace Themis {

class CConfig;
class CPlaneEx;

/**
    摜ɃtB^{

    ݒ荀ځF

        Bool    Filter
        Num     FilterGray (0 - 2)
        Bool    FilterLevelRev
        Num     FilterLevelRevLow (0 - 255)
        Num     FilterLevelRevHigh (0 - 255)
        Bool    FilterGammaRev
        Num     FilterGammaRevValue (0 - 100)
        Bool    FilterBC
        Num     FilterBCBright (-128 - 128)
        Num     FilterBCContrast (-128 - 128)
        Bool    FilterMedian
        Num     FilterSharp (0 - 4)
        Bool    FilterGauss
        Num     FilterGaussValue (0 - )
        Bool    FilterUnsharp
        Num     FilterUnsharpValue (0 - )
        Bool    FilterNeg
        Num     FilterRot1 (0 - 3)
        Num     FilterRot2 (0 - 2)
        Bool    FilterAlpha
        Color   FilterAlphaBg
        Bool    FilterAlphaCheck

*/
class CImageFilter {
public:
    CImageFilter(CConfig& rConfig);
    ~CImageFilter();

    /// Ō̏ŎۂɂPȏ̃tB^sǂԂ
    bool IsFiltering() const;

    /// tB^sBbHasAlpha̓`lĂ邩ǂ
    void Filter(std::tr1::shared_ptr<CPlaneEx>& pPlane, std::tr1::shared_ptr<CPlaneEx>& pTempPlane, bool& bHasAlpha);

private:
    CConfig&    m_rConfig;
    bool        m_bFiltering;
};

}
