#pragma once
#include "Image.h"
namespace Themis {

/**
 * TGAǂݍ݁B
 */
class CTgaLoader : public IImageLoader {
public:
    CTgaLoader();
    ~CTgaLoader();

    bool Load(const std::tr1::shared_ptr<CFileData>& fileData, bool bRenderOnlyAtOnce);
    CSize GetSize() const;
    void Render(CPlane& dst, const CPoint& pt, bool bRenderOnlyAtOnce);
    bool HasAlpha() const { return true; }
    string GetTypeName() const { return L"TGA"; }
    string GetTypeFileName() const { return L"*.tga;*.targa;*.vda;*.icb;*.vst"; }

private:
    auto_ptr<CMemoryPlane> plane;
};

/// TGAt@Cǂݍ݃NXFactory
typedef DefaultFactory<CTgaLoader, IImageLoader>   CTgaLoaderFactory;

}
