#pragma once
namespace Themis {

/**

    g

    [IroIro.h]
@code

    struct IroIroData;

    class IroIro {
        ImplData<IroIroData> data;
    public:
        IroIro();
        ~IroIro();
    };

@endcode
    [IroIro.cpp]
@code

    struct IroIroData {
        int iroiro;
    };

    IroIro::IroIro() {
        data->iroiro = 0;
    }

    IroIro::~IroIro() {
    }
@endcode
*/
template<class T> class ImplData : private boost::noncopyable {
public:
    ImplData() : data(NULL) { data = new T(); }
    ~ImplData() { boost::checked_delete(data); }

    T* Get() const { return data; }
    T* operator->() const { return Get(); }
    T& operator*() const { return *Get(); }

private:
    T* data;
};

}
