#pragma once
namespace Themis {

/**
    std::tr1::shared_ptr<T> ƁA쐬Ɏw肷DxNXB

    rIy[^ł̗Dx̔rƂB
    ReiɂގƂɕ֗B

, private boost::totally_ordered<PriorityObject<T>, int>
*/
template<class T> class PriorityObject : private boost::totally_ordered<PriorityObject<T> > {
public:
    PriorityObject(const std::tr1::shared_ptr<T>& p, int n): m_n(n), m_p(p) {}
    ~PriorityObject() {}
    /// std::tr1::shared_ptrexplicitʓ|Ȃ̂ŁBB
    PriorityObject(T* p, int n): m_n(n), m_p(p) {}

    //@{ DxɂrZ
    bool operator<(const PriorityObject<T>& r) const { return m_n < r.m_n; }
    bool operator==(const PriorityObject<T>& r) const { return m_n == r.m_n; }
    bool operator<(int n) const { return m_n < n; }
    bool operator==(int n) const { return m_n == n; }
    //@}

    /// Dx̎擾
    const int GetPriority() const { return m_n; }

    //@{ |C^̎擾Ƃ
    T* operator->() const { return m_p.operator->(); }
    T& operator*() const { return m_p.operator*(); }
    T* Get() const { return m_p.get(); }
    std::tr1::shared_ptr<T>& GetPtr() { return m_p; }
    const std::tr1::shared_ptr<T>& GetPtr() const { return m_p; }
    //@}

private:
    int m_n;    //constɂƑZqgȂĕsւȂ̂ŁBB
    std::tr1::shared_ptr<T> m_p;
};


}
