#pragma once
namespace Themis {

/// std::tr1::shared_ptr쐬
template<class T> inline std::tr1::shared_ptr<T> shared_ptr(T* p) {
    return std::tr1::shared_ptr<T>(p);
}

namespace Detail {
    template<class T> struct FakeDeleter { void operator()(T* p) {} };
}
/// 폜Ȃstd::tr1::shared_ptr쐬
template<class T> inline std::tr1::shared_ptr<T> shared_ptr_fake(T* p) {
    return std::tr1::shared_ptr<T>(p, Detail::FakeDeleter<T>());
}

}
